b136e25b19ab686950d8720fa7c5ce63f5977009
[openafs.git] / src / packaging / RedHat / openafs-kmodtool
1 #!/bin/bash
2
3 # kmodtool - Helper script for building kernel module RPMs
4 # Copyright (c) 2003-2007 Ville Skytt√§ <ville.skytta@iki.fi>,
5 #                         Thorsten Leemhuis <fedora@leemhuis.info>
6 #
7 # Modified by Simon Wilkinson for OpenAFS
8
9 # Permission is hereby granted, free of charge, to any person obtaining
10 # a copy of this software and associated documentation files (the
11 # "Software"), to deal in the Software without restriction, including
12 # without limitation the rights to use, copy, modify, merge, publish,
13 # distribute, sublicense, and/or sell copies of the Software, and to
14 # permit persons to whom the Software is furnished to do so, subject to
15 # the following conditions:
16 #
17 # The above copyright notice and this permission notice shall be
18 # included in all copies or substantial portions of the Software.
19 #
20 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
21 # EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
22 # MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
23 # NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
24 # LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
25 # OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
26 # WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
27
28 shopt -s extglob
29
30 myprog="kmodtool"
31 myver="0.10.13"
32 knownvariants=@(BOOT|PAE?(-debug)|@(big|huge)mem|debug|enterprise|kdump|?(large)smp?(-debug)|uml|xen?([0U])?(-PAE))
33 kmod_name=
34 kver=
35 verrel=
36 variant=
37
38 get_verrel ()
39 {
40   verrel=${1:-$(uname -r)}
41   verrel=${verrel%%$knownvariants}
42   case "$verrel" in
43     *.el6.elrepo*) verrel="`echo ${verrel} | sed -e 's/^\(.*.el6.elrepo[^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
44     *.el6*)        verrel="`echo ${verrel} | sed -e 's/^\(.*.el6[^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
45     *.fc9*)        verrel="`echo ${verrel} | sed -e 's/^\(.*.fc9[^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
46     *.fc1?*)       verrel="`echo ${verrel} | sed -e 's/^\(.*.fc1[0-9][^\.]*\)\.[^\.]\+.\?$/\1/'`" ;;
47   esac
48 }
49
50 print_verrel ()
51 {
52   get_verrel $@
53   echo "${verrel}"
54 }
55
56 get_variant ()
57 {
58   get_verrel $@
59   variant=${1:-$(uname -r)}
60   variant=${variant##$verrel}
61   variant=${variant:-'""'}
62 }
63
64 print_variant ()
65 {
66   get_variant $@
67   echo "${variant}"
68 }
69
70
71 get_rpmtemplate ()
72 {
73     local variant="${1}"
74     local dashvariant="${variant:+-${variant}}"
75     case "$verrel" in
76         *.el6*) kdep="kernel-%{_target_cpu} = ${verrel}${variant}"     ;;
77         *.EL*) kdep="kernel${dashvariant}-%{_target_cpu} = ${verrel}" ;;
78         *)     kdep="kernel-%{_target_cpu} = ${verrel}${variant}"     ;;
79     esac
80     case "$verrel" in
81         *.el6*)   kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
82         *.fc9*)   kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
83         *.fc1?*)  kname="${verrel}.%{_target_cpu}${variant:+.${variant}}" ;;
84         *)        kname="${verrel}${variant}"                             ;;
85     esac
86
87     cat <<EOF
88 %package       -n kmod-${kmod_name}${dashvariant}
89 Summary:          ${kmod_name} kernel module(s)
90 Group:            System Environment/Kernel
91 Provides:         kernel-modules = ${kname}
92 Provides:         ${kmod_name}-kmod = %{?epoch:%{epoch}:}%{version}-%{release}
93 Provides:         openafs-kernel = %{PACKAGE_VERSION}
94 Requires:         ${kdep}
95 Requires:         ${kmod_name}-kmod-common >= %{?epoch:%{epoch}:}%{version}
96 Requires(post):   /sbin/depmod
97 Requires(postun): /sbin/depmod
98 Release:          %{pkgrel}.%(echo ${verrel} | tr - _)
99 BuildRequires:    kernel${dashvariant}-devel-%{_target_cpu} = ${verrel}
100 %description   -n kmod-${kmod_name}${dashvariant}
101 This package provides the ${kmod_name} kernel modules built for the Linux
102 kernel ${kname} for the %{_target_cpu} family of processors.
103 %post          -n kmod-${kmod_name}${dashvariant}
104 /sbin/depmod -aeF /boot/System.map-${kname} ${kname} > /dev/null || :
105 %postun        -n kmod-${kmod_name}${dashvariant}
106 /sbin/depmod -aF /boot/System.map-${kname} ${kname} &> /dev/null || :
107 %files         -n kmod-${kmod_name}${dashvariant}
108 %defattr(644,root,root,755)
109 /lib/modules/${kname}/extra/${kmod_name}/
110
111 EOF
112 }
113
114 print_rpmtemplate ()
115 {
116   kmod_name="${1}"
117   shift
118   kver="${1}"
119   get_verrel "${1}"
120   shift
121   if [ -z "${kmod_name}" ] ; then
122     echo "Please provide the kmodule-name as first parameter." >&2
123     exit 2
124   elif [ -z "${kver}" ] ; then
125     echo "Please provide the kver as second parameter." >&2
126     exit 2
127   elif [ -z "${verrel}" ] ; then
128     echo "Couldn't find out the verrel." >&2
129     exit 2
130   fi
131
132   for variant in "$@" ; do
133     get_rpmtemplate "${variant}"
134   done
135 }
136
137 usage ()
138 {
139   cat <<EOF
140 You called: ${invocation}
141
142 Usage: ${myprog} <command> <option>+
143  Commands:
144   verrel <uname>                               
145     - Get "base" version-release.
146   variant <uname>                               
147     - Get variant from uname.
148   rpmtemplate <mainpgkname> <uname> <variants> 
149     - Return a template for
150   version  
151     - Output version number and exit.
152 EOF
153 }
154
155 invocation="$(basename ${0}) $@"
156 while [ "${1}" ] ; do
157   case "${1}" in
158     verrel)
159       shift
160       print_verrel $@
161       exit $?
162       ;;
163     variant)
164       shift
165       print_variant $@
166       exit $?
167       ;;
168     rpmtemplate)
169       shift
170       print_rpmtemplate "$@"
171       exit $?
172       ;;
173     version)
174       echo "${myprog} ${myver}"
175       exit 0
176       ;;
177     *)
178       echo "Error: Unknown option '${1}'." >&2
179       usage >&2
180       exit 2
181       ;;
182   esac
183 done
184
185 # Local variables:
186 # mode: sh
187 # sh-indentation: 2
188 # indent-tabs-mode: nil
189 # End:
190 # ex: ts=2 sw=2 et